#!/usr/bin/env python
############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import sys, time, urlparse, optparse
import ZSI
from twisted.python import log
import pyGridWare.generated.stubs.clwrappertool as TOOL
from pyGridWare.utility.scripts.client import GetOptParser, GetPortKWArgs, SetUp


############################################################################
# Counter
#     add
#     createCounter
############################################################################
def create(port):
    request = TOOL.createCLWrapperTool_catRequest()
    class Holder: pass
    request._arguments = Holder()
    msg = port.create(request)
    epr = "\tAddress -- %s\tRefProp -- %s\t\tany -- %s" \
        %(msg._EndpointReference._Address,
          msg._EndpointReference._ReferenceProperties,
          msg._EndpointReference._ReferenceProperties._any)
    log.msg("----- create -----\n%s" %epr)
    return msg

############################################################################
# ResourceLifetime
#     Destroy
#     GetCurrentMessage
#     SetTerminationTime
############################################################################
def Destroy(port):
    log.msg("----- destroy ----- ")
    request = TOOL.DestroyRequest()
    msg = port.Destroy(request)
    log.msg("RESPONSE: ", msg)

def SetTerminationTime(port, interval):
    log.msg("----- SetTerminationTime ----- ")
    request = TOOL.SetTerminationTimeRequest()
    request._RequestedTerminationTime = time.gmtime(time.time()+interval)
    msg = port.SetTerminationTime(request)
    log.msg("TerminationTime: ", msg._NewTerminationTime)
    log.msg("CurrrentTime:    ", msg._CurrentTime)


############################################################################
# ResourceProperties
#     GetResourceProperty
############################################################################
def GetResourceProperty(port):
    log.msg("----- GetResourceProperty ----- ")
    request = TOOL.GetResourcePropertyRequest(("urn:CLWrapperTool_cat_Schema", "stdout"))
    msg = port.GetResourceProperty(request)
    f = open('test.tar.gz' , 'wb+')
    f.write(msg._any[0])
    f.close()

def main():
    op = GetOptParser('CLWrapperToolService')
    (options, args) = op.parse_args()
    SetUp(options)
    kw = GetPortKWArgs(options)

    locator = TOOL.CLWrapperTool_catLocator()
    port = locator.getCLWrapperTool_catPortType(**kw)
    response = create(port)

    kw['endPointReference'] = response._EndpointReference
    port = locator.getCLWrapperTool_catPortType(**kw)

    GetResourceProperty(port)

 
if __name__ == '__main__':
    main()

