############################################################################
# Matt Rodriguez, LBNL
# See Copyright for copyright notice!
#########################################################################
from pyGridWare.wsrf.resource import WSResource as WSResourceService
from pyGridWare.security.gss.GssSignatureHandler import GssSignatureHandler


class GssSecureResourceMixIn(WSResourceService):
    def __init__(self, post):
        WSResourceService.__init__(self, post)
        self._sigHandler = GssSignatureHandler()
        
    def verify(self, ps):
        self._sigHandler.verify(ps)

    def sign(self, sw):
        self._sigHandler.sign(sw)
