############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
# Generated by setup.py
###########################################################################

import time, urlparse
from pyGridWare.lifetime.ResourceLifetime import ImmediateResourceTermination
from pyGridWare.lifetime.ResourceLifetime import ScheduledResourceTermination
from pyGridWare.generated.services.printerservice.PrinterFactoryService import *
from pyGridWare.generated.services.printerservice.PrinterService import PrinterServiceWSRF
from pyGridWare.addressing.AddressingUtils import AddressingUtils

class PrinterService(PrinterServiceWSRF):
    def wsa_GetResourceProperty(self, ps, address):
         print "XXX"*900
         return PrinterServiceWSRF.wsa_GetResourceProperty(self, ps, address)
         

class PrinterFactoryService(PrinterFactoryServiceWSRF):
        
    def wsa_CreatePrinter(self, ps, address):
        scheme,netloc,path,params,query,fragment = urlparse.urlparse(self.url)
        #for p in path.split('/') + ['PrinterService',]:
        #    child = self.server._port.factory.resource.getStaticEntity('wsrf')
        #    print "CHILD(%s): " %p, child
        path += '/PrinterService'
        child = self.server._port.factory.resource.children['wsrf']
        child = child.children['services']
        child = child.children['PrinterFactoryService']
        child = child.children['PrinterService']

        if child.url is None:
            child.url = urlparse.urlunparse((scheme,netloc,path,params,query,fragment))

        response = PrinterFactoryServiceWSRF.wsa_CreatePrinter(self, ps, address)

        # Set up PrinterPort Resource Properties.
        ctx = child.NewResourceContextPrinterPort()
        #ctx.properties.printer_reference
        #ctx.properties.printer_name
        #ctx.properties.printer_state
        #ctx.properties.printer_is_accepting_jobs
        ctx.properties.queued_job_count = 0
        #ctx.properties.operations_supported
        #ctx.properties.document_format_supported
        #ctx.properties.job_hold_until_default
        #ctx.properties.job_hold_until_supported 
        #ctx.properties.QueryExpressionDialect
        #ctx.properties.job_properties

        epr = AddressingUtils.createEndpointReference(ctx)
        response._printer_reference = epr
        return response



